#!/usr/bin/env python

"""
Number utility functions.
"""
import pdb

def i2b(num, num_bytes):
	"""
	Convert a number into bytes
	"""
	out = ""
	for byte in range(num_bytes):
		num = int(num) # Line added by JSP 19-8-2020 convert num fron float to int
		out += chr(num & 0xFF)
		num >>= 8
		num = float(num) # Line added by JSP 19-8-2020 convert num fron int to float
	return out


def b2i(data):
	"""
	Convert a stream of bytes into a number
	"""
	if type(data) is int:
		return data
	out = 0
	for char in data[::-1]:
		out <<= 8
		out |= char
	return out


# Aliases for i2b which converts numbers into various length byte streams.
# Functions named according to conventional 32-bit word wisdom (as used by the
# protocol).
def byte(num): return i2b(num, 1)
def half(num): return i2b(num, 2)
def word(num): return i2b(num, 4)
def dblw(num): return i2b(num, 8)


def bits_to_bytes(bits):
	"""
	Round up to the next whole number of bytes.
	"""
	return (bits + 7) // 8
